Index: trunk/sources/HeuristicLab.Optimization.Views/3.3/AlgorithmView.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimization.Views/3.3/AlgorithmView.Designer.cs	(revision 3975)
+++ trunk/sources/HeuristicLab.Optimization.Views/3.3/AlgorithmView.Designer.cs	(revision 4011)
@@ -50,5 +50,4 @@
       this.parameterCollectionView = new HeuristicLab.Core.Views.ParameterCollectionView();
       this.problemTabPage = new System.Windows.Forms.TabPage();
-      this.problemPanel = new System.Windows.Forms.Panel();
       this.problemViewHost = new HeuristicLab.MainForm.WindowsForms.ViewHost();
       this.openProblemButton = new System.Windows.Forms.Button();
@@ -69,5 +68,4 @@
       this.parametersTabPage.SuspendLayout();
       this.problemTabPage.SuspendLayout();
-      this.problemPanel.SuspendLayout();
       this.resultsTabPage.SuspendLayout();
       this.runsTabPage.SuspendLayout();
@@ -123,5 +121,5 @@
       // problemTabPage
       // 
-      this.problemTabPage.Controls.Add(this.problemPanel);
+      this.problemTabPage.Controls.Add(this.problemViewHost);
       this.problemTabPage.Controls.Add(this.openProblemButton);
       this.problemTabPage.Controls.Add(this.newProblemButton);
@@ -134,28 +132,19 @@
       this.problemTabPage.UseVisualStyleBackColor = true;
       // 
-      // problemPanel
-      // 
-      this.problemPanel.AllowDrop = true;
-      this.problemPanel.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
-                  | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
-      this.problemPanel.Controls.Add(this.problemViewHost);
-      this.problemPanel.Location = new System.Drawing.Point(6, 36);
-      this.problemPanel.Name = "problemPanel";
-      this.problemPanel.Size = new System.Drawing.Size(659, 332);
-      this.problemPanel.TabIndex = 3;
-      this.problemPanel.DragOver += new System.Windows.Forms.DragEventHandler(this.problemPanel_DragEnterOver);
-      this.problemPanel.DragDrop += new System.Windows.Forms.DragEventHandler(this.problemPanel_DragDrop);
-      this.problemPanel.DragEnter += new System.Windows.Forms.DragEventHandler(this.problemPanel_DragEnterOver);
-      // 
       // problemViewHost
       // 
+      this.problemViewHost.AllowDrop = true;
       this.problemViewHost.Content = null;
-      this.problemViewHost.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.problemViewHost.Location = new System.Drawing.Point(0, 0);
+      this.problemViewHost.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+                  | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.problemViewHost.Location = new System.Drawing.Point(6, 36);
       this.problemViewHost.Name = "problemViewHost";
       this.problemViewHost.Size = new System.Drawing.Size(659, 332);
-      this.problemViewHost.TabIndex = 0;
+      this.problemViewHost.TabIndex = 3;
       this.problemViewHost.ViewType = null;
+      this.problemViewHost.DragOver += new System.Windows.Forms.DragEventHandler(this.problemViewHost_DragEnterOver);
+      this.problemViewHost.DragDrop += new System.Windows.Forms.DragEventHandler(this.problemViewHost_DragDrop);
+      this.problemViewHost.DragEnter += new System.Windows.Forms.DragEventHandler(this.problemViewHost_DragEnterOver);
       // 
       // openProblemButton
@@ -327,5 +316,4 @@
       this.parametersTabPage.ResumeLayout(false);
       this.problemTabPage.ResumeLayout(false);
-      this.problemPanel.ResumeLayout(false);
       this.resultsTabPage.ResumeLayout(false);
       this.runsTabPage.ResumeLayout(false);
@@ -355,6 +343,4 @@
     protected System.Windows.Forms.TabPage runsTabPage;
     protected RunCollectionView runsView;
-    protected System.Windows.Forms.Panel problemPanel;
-
   }
 }
Index: trunk/sources/HeuristicLab.Optimization.Views/3.3/AlgorithmView.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimization.Views/3.3/AlgorithmView.cs	(revision 3975)
+++ trunk/sources/HeuristicLab.Optimization.Views/3.3/AlgorithmView.cs	(revision 4011)
@@ -216,5 +216,5 @@
       Content.Prepare(false);
     }
-    protected virtual void problemPanel_DragEnterOver(object sender, DragEventArgs e) {
+    protected virtual void problemViewHost_DragEnterOver(object sender, DragEventArgs e) {
       e.Effect = DragDropEffects.None;
       Type type = e.Data.GetData("Type") as Type;
@@ -227,5 +227,5 @@
       }
     }
-    protected virtual void problemPanel_DragDrop(object sender, DragEventArgs e) {
+    protected virtual void problemViewHost_DragDrop(object sender, DragEventArgs e) {
       if (e.Effect != DragDropEffects.None) {
         IProblem problem = e.Data.GetData("Value") as IProblem;
Index: trunk/sources/HeuristicLab.Optimization.Views/3.3/BatchRunView.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimization.Views/3.3/BatchRunView.Designer.cs	(revision 3975)
+++ trunk/sources/HeuristicLab.Optimization.Views/3.3/BatchRunView.Designer.cs	(revision 4011)
@@ -48,5 +48,4 @@
       this.tabControl = new System.Windows.Forms.TabControl();
       this.algorithmTabPage = new System.Windows.Forms.TabPage();
-      this.algorithmPanel = new System.Windows.Forms.Panel();
       this.algorithmViewHost = new HeuristicLab.MainForm.WindowsForms.ViewHost();
       this.openAlgorithmButton = new System.Windows.Forms.Button();
@@ -66,5 +65,4 @@
       this.tabControl.SuspendLayout();
       this.algorithmTabPage.SuspendLayout();
-      this.algorithmPanel.SuspendLayout();
       this.runsTabPage.SuspendLayout();
       ((System.ComponentModel.ISupportInitialize)(this.repetitionsNumericUpDown)).BeginInit();
@@ -96,5 +94,5 @@
       // algorithmTabPage
       // 
-      this.algorithmTabPage.Controls.Add(this.algorithmPanel);
+      this.algorithmTabPage.Controls.Add(this.algorithmViewHost);
       this.algorithmTabPage.Controls.Add(this.openAlgorithmButton);
       this.algorithmTabPage.Controls.Add(this.newAlgorithmButton);
@@ -107,28 +105,19 @@
       this.algorithmTabPage.UseVisualStyleBackColor = true;
       // 
-      // algorithmPanel
-      // 
-      this.algorithmPanel.AllowDrop = true;
-      this.algorithmPanel.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+      // algorithmViewHost
+      // 
+      this.algorithmViewHost.Content = null;
+      this.algorithmViewHost.AllowDrop = true;
+      this.algorithmViewHost.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
                   | System.Windows.Forms.AnchorStyles.Left)
                   | System.Windows.Forms.AnchorStyles.Right)));
-      this.algorithmPanel.Controls.Add(this.algorithmViewHost);
-      this.algorithmPanel.Location = new System.Drawing.Point(6, 36);
-      this.algorithmPanel.Name = "algorithmPanel";
-      this.algorithmPanel.Size = new System.Drawing.Size(659, 306);
-      this.algorithmPanel.TabIndex = 3;
-      this.algorithmPanel.DragOver += new System.Windows.Forms.DragEventHandler(this.algorithmPanel_DragEnterOver);
-      this.algorithmPanel.DragDrop += new System.Windows.Forms.DragEventHandler(this.algorithmPanel_DragDrop);
-      this.algorithmPanel.DragEnter += new System.Windows.Forms.DragEventHandler(this.algorithmPanel_DragEnterOver);
-      // 
-      // algorithmViewHost
-      // 
-      this.algorithmViewHost.Content = null;
-      this.algorithmViewHost.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.algorithmViewHost.Location = new System.Drawing.Point(0, 0);
+      this.algorithmViewHost.Location = new System.Drawing.Point(6, 36);
       this.algorithmViewHost.Name = "algorithmViewHost";
       this.algorithmViewHost.Size = new System.Drawing.Size(659, 306);
-      this.algorithmViewHost.TabIndex = 0;
+      this.algorithmViewHost.TabIndex = 3;
       this.algorithmViewHost.ViewType = null;
+      this.algorithmViewHost.DragOver += new System.Windows.Forms.DragEventHandler(this.algorithmViewHost_DragEnterOver);
+      this.algorithmViewHost.DragDrop += new System.Windows.Forms.DragEventHandler(this.algorithmViewHost_DragDrop);
+      this.algorithmViewHost.DragEnter += new System.Windows.Forms.DragEventHandler(this.algorithmViewHost_DragEnterOver);
       // 
       // openAlgorithmButton
@@ -317,5 +306,4 @@
       this.tabControl.ResumeLayout(false);
       this.algorithmTabPage.ResumeLayout(false);
-      this.algorithmPanel.ResumeLayout(false);
       this.runsTabPage.ResumeLayout(false);
       ((System.ComponentModel.ISupportInitialize)(this.repetitionsNumericUpDown)).EndInit();
@@ -342,6 +330,4 @@
     private RunCollectionView runsView;
     private System.Windows.Forms.Button pauseButton;
-    private System.Windows.Forms.Panel algorithmPanel;
-
   }
 }
Index: trunk/sources/HeuristicLab.Optimization.Views/3.3/BatchRunView.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimization.Views/3.3/BatchRunView.cs	(revision 3975)
+++ trunk/sources/HeuristicLab.Optimization.Views/3.3/BatchRunView.cs	(revision 4011)
@@ -140,5 +140,6 @@
     }
     private void repetitionsNumericUpDown_ValueChanged(object sender, EventArgs e) {
-      Content.Repetitions = (int)repetitionsNumericUpDown.Value;
+      if (Content != null)
+        Content.Repetitions = (int)repetitionsNumericUpDown.Value;
     }
     private void newAlgorithmButton_Click(object sender, EventArgs e) {
@@ -197,5 +198,5 @@
       Content.Prepare(false);
     }
-    private void algorithmPanel_DragEnterOver(object sender, DragEventArgs e) {
+    private void algorithmViewHost_DragEnterOver(object sender, DragEventArgs e) {
       e.Effect = DragDropEffects.None;
       if (ReadOnly)
@@ -210,5 +211,5 @@
       }
     }
-    private void algorithmPanel_DragDrop(object sender, DragEventArgs e) {
+    private void algorithmViewHost_DragDrop(object sender, DragEventArgs e) {
       if (e.Effect != DragDropEffects.None) {
         IAlgorithm algorithm = e.Data.GetData("Value") as IAlgorithm;
Index: trunk/sources/HeuristicLab.Optimization.Views/3.3/EngineAlgorithmView.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimization.Views/3.3/EngineAlgorithmView.Designer.cs	(revision 3975)
+++ trunk/sources/HeuristicLab.Optimization.Views/3.3/EngineAlgorithmView.Designer.cs	(revision 4011)
@@ -58,5 +58,4 @@
       this.resultsTabPage.SuspendLayout();
       this.runsTabPage.SuspendLayout();
-      this.problemPanel.SuspendLayout();
       ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).BeginInit();
       this.engineTabPage.SuspendLayout();
@@ -148,5 +147,5 @@
       // problemPanel
       // 
-      this.problemPanel.Size = new System.Drawing.Size(693, 399);
+      this.problemViewHost.Size = new System.Drawing.Size(693, 399);
       // 
       // nameTextBox
@@ -276,5 +275,4 @@
       this.resultsTabPage.ResumeLayout(false);
       this.runsTabPage.ResumeLayout(false);
-      this.problemPanel.ResumeLayout(false);
       ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).EndInit();
       this.engineTabPage.ResumeLayout(false);
Index: trunk/sources/HeuristicLab.Optimization.Views/3.3/RunView.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimization.Views/3.3/RunView.cs	(revision 3975)
+++ trunk/sources/HeuristicLab.Optimization.Views/3.3/RunView.cs	(revision 4011)
@@ -103,6 +103,6 @@
     }
 
+    private string selectedName;
     private void FillListView() {
-      string selectedName = null;
       if (listView.SelectedItems.Count == 1) selectedName = listView.SelectedItems[0].SubItems[0].Text;
 
@@ -117,4 +117,5 @@
           for (int i = 0; i < listView.Columns.Count; i++)
             listView.Columns[i].AutoResize(ColumnHeaderAutoResizeStyle.ColumnContent);
+          selectedName = null;
         }
       }
Index: trunk/sources/HeuristicLab.Optimization.Views/3.3/UserDefinedAlgorithmView.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimization.Views/3.3/UserDefinedAlgorithmView.Designer.cs	(revision 3975)
+++ trunk/sources/HeuristicLab.Optimization.Views/3.3/UserDefinedAlgorithmView.Designer.cs	(revision 4011)
@@ -54,5 +54,4 @@
       this.resultsTabPage.SuspendLayout();
       this.runsTabPage.SuspendLayout();
-      this.problemPanel.SuspendLayout();
       ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).BeginInit();
       this.globalScopeTabPage.SuspendLayout();
@@ -152,5 +151,4 @@
       this.resultsTabPage.ResumeLayout(false);
       this.runsTabPage.ResumeLayout(false);
-      this.problemPanel.ResumeLayout(false);
       ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).EndInit();
       this.globalScopeTabPage.ResumeLayout(false);